#ifndef _COLOR_H
#define _COLOR_H
#include <iosfwd>
#include <cassert>

enum Color {
  RED=0,
  EMPTY=1,
  BLUE=2,
  EDGE=3,
};
std::ostream& operator<<(std::ostream& os,Color const& c);
std::istream& operator>>(std::istream& os,Color & c);
static inline Color alt(Color c){
  assert(c!=EDGE);
  return static_cast<Color>(2-c);
}
#endif /* _COLOR_H */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
