/**
 * $B$I$N<j$G$b>!$F$k$H$$$&6ILL$,$"$k$+(B?
 */
#include "board.h"
#include "boardTable.h"
#include <iostream>
#include <vector>
using namespace std;

void testput(Board& board,hash_map<PackedBoard,int> & s2iMap,int red, int blue,int i,int& count)
{
  if(red==0 && blue==0){
    PackedBoard packed=clearRot(board.packRev());
    hash_map<PackedBoard,int>::const_iterator it=s2iMap.find(packed);
    if(it==s2iMap.end()){
#if 0
      Board board1;
      board1.init(packed);
      std::cerr << board1 << std::endl;
#endif
      s2iMap[packed]=0;
      count++;
    }
    return;
  }
  if(i>=25) return;
  if(red>0){
    board[i]=RED;
    testput(board,s2iMap,red-1,blue,i+1,count);
    board[i]=EMPTY;
  }
  if(blue>0){
    board[i]=BLUE;
    testput(board,s2iMap,red,blue-1,i+1,count);
    board[i]=EMPTY;
  }
  testput(board,s2iMap,red,blue,i+1,count);
}

int main()
{
  BoardTable table;
  table.load("simple.dat");
  hash_map<PackedBoard,int> s2iMap;
  Board board;
  int count0=0;
  int count1=0;
  for(size_t i=0;i<table.allBoard.size();i++){
    if(table.winOrLose[i]>0 && table.winOrLose[i]!=100){
      int c1=0;
      for(size_t j=0;j<table.allNexts[i].size();j++){
	int k=table.allNexts[i][j];
	if(table.winOrLose[k]>0)c1++;
      }
      if(c1==0){
	board.init(table.allBoard[i]);
	cerr << board << endl;
	count0++;
      }
      else
	count1++;
    }
  }
  cout << count0 << " , " << count1 << endl;
  return 0;
}
