#include "playTable.h"
#include "fileIO.h"
#include <iostream>

PlayTable PlayTableFile::find(PackedBoard const& packed)
{
  unsigned int hVal=hash(clearRot(packed));
  std::cerr << "hVal=" << hVal << std::endl;
  ifs.seekg(hVal*(8+8+1)*PlayTableFile::maxGroupSize);
  std::cerr << "seekSize=" << hVal*(8+8+1)*PlayTableFile::maxGroupSize << std::endl;
  for(int i=0;i<PlayTableFile::maxGroupSize;i++){
    std::cerr << "i=" << i << std::endl;
    PlayTable pt;
    ifs >> pt;
    if(packed==pt.packed) return pt;
    if(isInvalid(pt.packed)){
      assert(0);
    }
  }
  assert(0);
}

istream& operator>>(istream& is,PlayTable & pt)
{
  pt.packed=getLL(is);
  pt.bestNext=getLL(is);
  pt.winOrLose=getC(is);
  return is;
}

ostream& operator<<(ostream& os,PlayTable const& pt)
{
  putLL(os,pt.packed);
  putLL(os,pt.bestNext);
  putC(os,pt.winOrLose);
  return os;
}
