#ifndef _POSITION_INDEX_TABLE_H
#define _POSITION_INDEX_TABLE_H
#include <cassert>
#include <iosfwd>
using namespace std;
/**
 9 x 6$B$N%5%$%:$,4pK\(B
 * * * * * * * * *
 * . . . . * . . .
 * . . . . * . . .
 * . . . . * . . .
 * . . . . * * * *
 * * * * * * 
 */

/**
 * 0-24$B$N(BPosition$B$+$i(B0-54$B$N(Bindex$B$XJQ49$9$k!%(B
 */
class Pos2IndexTable{
  int index[8][25];
 public:
  Pos2IndexTable();
  /**
   */
  int getIndex(int type,int pos)const{
    assert(0<=type && type<8);
    assert(0<=pos && type<25);
    return index[type][pos];
  }
  /**
   * type==0$B$N;~$N(Bindex$B$rJV$9!%(B
   */
  int getIndex(int pos)const{
    return getIndex(0,pos);
  }
};
ostream& operator<<(ostream& os,Pos2IndexTable const& table);
extern Pos2IndexTable pos2IndexTable;
#endif /* _POSITION_INDEX_TABLE_H */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
