/**
 * $B>ZL@LZ$N%5%$%:$r5a$a$k!%(B
 */
#include "boardTable.h"
#include <iostream>
#include <algorithm>
#include <vector>
using namespace std;

int main()
{
  BoardTable table;
  table.load("simple.dat");
  size_t size=table.winOrLose.size();
  vector<int> treeSize(size,100000);
  int changed=1;
  int count=0;
  while(changed){
    cerr << count++ << " : " << changed << endl;
    changed=0;
    for(size_t i=0;i<size;i++){
      int oldValue=treeSize[i];
      int newValue=oldValue;
      if(table.winOrLose[i]<0){
	int sum=0;
	for(size_t j=0;j<table.allNexts[i].size();j++){
	  int k=table.allNexts[i][j];
	  sum+=treeSize[k];
	}
	newValue=sum+1;
      }
      else if(table.winOrLose[i]==100){
	treeSize[i]=1;
      }
      else if(table.winOrLose[i]>0){
	int minS=1000000000;
	for(size_t j=0;j<table.allNexts[i].size();j++){
	  int k=table.allNexts[i][j];
	  if(table.winOrLose[k]<0) 
	    minS=min(minS,treeSize[k]);
	}
	newValue=minS+1;
      }
      if(newValue!=oldValue){
	treeSize[i]=newValue;
	changed++;
      }
    }
  }
  for(int i=0;i<10;i++){
    Board board;
    board.init(table.allBoard[i]);
    cout << "------" << endl;
    cout << treeSize[i] << endl;
    cout << board << endl;
  }
  int minS=0;
  for(size_t i=0;i<size;i++){
    if(table.winOrLose[i]>0 && treeSize[i]>minS){
      minS=treeSize[i];
      Board board;
      board.init(table.allBoard[i]);
      cout << "------" << endl;
      cout << treeSize[i] << endl;
      cout << board << endl;
    }
  }
  return 0;
}
