/**
 * $B6ILL?t$r?t$($k!%(B
 */
#include "board.h"
#include "boardTable.h"
#include <iostream>
#include <vector>
using namespace std;

void testput(Board& board,hash_map<PackedBoard,int> & s2iMap,int red, int blue,int i,int& count)
{
  if(red==0 && blue==0){
    PackedBoard packed=clearRot(board.packRev());
    hash_map<PackedBoard,int>::const_iterator it=s2iMap.find(packed);
    if(it==s2iMap.end()){
#if 0
      Board board1;
      board1.init(packed);
      std::cerr << board1 << std::endl;
#endif
      s2iMap[packed]=0;
      count++;
    }
    return;
  }
  if(i>=25) return;
  if(red>0){
    board[i]=RED;
    testput(board,s2iMap,red-1,blue,i+1,count);
    board[i]=EMPTY;
  }
  if(blue>0){
    board[i]=BLUE;
    testput(board,s2iMap,red,blue-1,i+1,count);
    board[i]=EMPTY;
  }
  testput(board,s2iMap,red,blue,i+1,count);
}

int main()
{
  BoardTable table;
  table.load("unreachable.dat");
  hash_map<PackedBoard,int> s2iMap;
  Board board;
  vector<int> counts(9),winCounts(9),drawCounts(9),loseCounts(9);
  for(size_t i=0;i<table.allBoard.size();i++){
    board.init(table.allBoard[i]);
    int n=board.nStones();
    if(table.winOrLose[i]>0) winCounts[n]++;
    else if(table.winOrLose[i]<0) loseCounts[n]++;
    else {
      drawCounts[n]++;
      if(n==3){
	cout << "------" << endl;
	cout << board << endl;
      }
    }
    counts[n]++;
  }
  for(int i=0;i<9;i++){
    cout << i << " & " << winCounts[i] << " & " << drawCounts[i] <<
      " & " << loseCounts[i] << " & " << counts[i] << " \\\\ " << endl;
  }
  return 0;
}
