#include <fstream>
#include <iostream>
static inline void putC(ostream &ofs,char val){
  ofs.put(val);
}
static inline void putI(ostream &ofs,int val){
  putC(ofs,static_cast<char>((val>>24)&0xff));
  putC(ofs,static_cast<char>((val>>16)&0xff));
  putC(ofs,static_cast<char>((val>>8)&0xff));
  putC(ofs,static_cast<char>(val&0xff));
}
static inline void putLL(ostream &ofs,long long val){
  putI(ofs,static_cast<int>((val>>32ll)&0xffffffffll));
  putI(ofs,static_cast<int>(val&0xffffffffll));
}
static inline char getC(istream & is){
  char val;
  is.get(val);
  return val;
}
static inline int getI(istream& is){
  int val=((getC(is)&0xff)<<24);
  val|=(getC(is)&0xff)<<16;
  val|=(getC(is)&0xff)<<8;
  val|=getC(is)&0xff;
  return val;
}
static inline long long getLL(istream& is){
  long long val=(getI(is)&0xffffffffll)<<32ll;
  val|=(getI(is)&0xffffffffll);
  return val;
}
