#ifndef _PACKED_BOARD_H
#define _PACKED_BOARD_H
#include <ext/hash_map>
#include <cassert>
using namespace std;
using __gnu_cxx::hash_map;

using __gnu_cxx::hash_map;

typedef unsigned long long int PackedBoard;
namespace __gnu_cxx
{
  template<> struct hash<PackedBoard>
  { size_t operator()(PackedBoard __x) const { return __x; } };
}

static inline PackedBoard clearRot(PackedBoard p)
{
  return p& ~7ll;
}

static inline PackedBoard makeInvalid()
{
  return 0ull;
}

static inline bool isInvalid(PackedBoard p)
{
  return p==0ull;
}


#endif /* _PACKED_BOARD_H */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
