/**
 * $B=i4|6ILL$+$iE~C#IT2DG=$J6ILL$r5a$a$k!%(B
counts[1]=0
counts[2]=0
counts[3]=7
counts[4]=100
counts[5]=2717
counts[6]=18928
counts[7]=453539
counts[8]=40133
 */
#include "board.h"
#include "boardTable.h"
#include <iostream>
using namespace std;

PackedBoard p1;
void testput(BoardTable & table,Board& board,hash_map<PackedBoard,int> & s2iMap,int red, int blue,int i,int& count)
{
  if(red==0 && blue==0){
    PackedBoard packed=clearRot(board.packRev());
    if(packed==p1){
      cerr << "Found" << endl;
    }
    hash_map<PackedBoard,int>::const_iterator it=s2iMap.find(packed);
    if(it==s2iMap.end()){
      count++;
      table.s2i(s2iMap,packed);
    }
    return;
  }
  if(i>=25) return;
  if(red>0){
    board[i]=RED;
    testput(table,board,s2iMap,red-1,blue,i+1,count);
    board[i]=EMPTY;
  }
  if(blue>0){
    board[i]=BLUE;
    testput(table,board,s2iMap,red,blue-1,i+1,count);
    board[i]=EMPTY;
  }
  testput(table,board,s2iMap,red,blue,i+1,count);
}
int main()
{
  {
    Board b1(". . . .\n"
	     " . . .\n"
	     ". + - +\n"
	     " . . .\n"
	     ". . . .\n"
	     " . . .\n"
	     ". . . .\n");
    p1=clearRot(b1.packRev());
  }
  BoardTable table;
  table.load("simple.dat");
  hash_map<PackedBoard,int> s2iMap;
  size_t size=table.allBoard.size();
  for(size_t i=0;i<size;i++)
    s2iMap[table.allBoard[i]]=i;
  for(int i=1;i<9;i++){
    Board board;
    int count=0;
    testput(table,board,s2iMap,i-i/2,i/2,0,count);
    cerr << "counts[" << i << "]=" << count << endl;
  }
  cerr << "allBoard.size()=" << table.allBoard.size() << endl;
  for(size_t i=size;i<table.allBoard.size();i++){
    if((i%1000)==0) cerr << "i=" << i << endl;
    Board board1;
    PackedBoard packed=table.allBoard[i];
    board1.init(packed);
    vector<int> myNexts;
    vector<PackedBoard> nexts;
    if(board1.nStones()<8){
      if(board1.canWinByDrop())
	continue;
      board1.nextDrops(nexts);
    }
    else{
      if(board1.canWinByMove())
	continue;
      board1.nextMoves(nexts);
    }
    for(size_t j=0;j<nexts.size();j++){
      int index=table.s2i(s2iMap,clearRot(nexts[j]));
      table.allNexts[i].push_back(index);
    }
  }
  cerr << "allNext.size()=" << table.allNexts.size() << ",allBoard.size()=" << table.allBoard.size() << endl;
  cerr << "start makeWinLose" << endl;
  table.makeWinLose();
  table.save("unreachable.dat");
  return 0;
}
