/**
 * ZugZwang
 */
#include "board.h"
#include "boardTable.h"
#include <iostream>
using namespace std;

int main()
{
  BoardTable table;
  table.load("unreachable.dat");
  Board board;
  hash_map<PackedBoard,int> s2iMap;
  for(size_t i=0;i<table.allBoard.size();i++)
    s2iMap[table.allBoard[i]]=i;
  vector<int> counts(9),symCounts(9);
  for(size_t i=0;i<table.allBoard.size();i++){
    if(table.winOrLose[i]<0){
      board.init(table.allBoard[i]);
      if((board.nStones() % 2)==0){
	PackedBoard packed=clearRot(board.packRev());
	hash_map<PackedBoard,int>::iterator it=s2iMap.find(packed);
	if(it==s2iMap.end()){
	  std::cerr << "reverse is not found";
	  std::cerr << board << std::endl;
	}
	else{
	  int k=it->second;
	  if(table.winOrLose[k]<0){
	    counts[board.nStones()]++;
	    if((int)i==k) symCounts[board.nStones()]++;
	    std::cerr << board << std::endl;
	  }
	}
      }
    }
  }
  for(size_t i=0;i<9;i++){
    cout << i << " & " << counts[i] << "(" << symCounts[i] << ")" << "\\\\ \\hline" << endl;
  }
  return 0;
}
